
/******************************************************************************
* MODULE     : function_test.cc
* DESCRIPTION: Test functions
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "function.hpp"
using namespace mmx;

int
factorial (int i) {
  if (i == 0) return 1;
  return i * factorial (i-1);
}

extern function<int,int,remember_function> fib;

int
fibonacci (int i) {
  if (i <= 1) return 1;
  return fib (i-1) + fib (i-2);
}

function<int,int,remember_function> fib (fibonacci, "fibonacci");

int
main () {
  function<int,int> f (factorial, "factorial");
  function<int,int> g= 123;
  function<int,int,remember_function> h= fib;
  cout << "f\t= " << f << "\n";
  cout << "g\t= " << g << "\n";
  cout << "h\t= " << h << "\n";
  cout << "f(10)\t= " << f(10) << "\n";
  cout << "g(10)\t= " << g(10) << "\n";
  cout << "h(35)\t= " << h(35) << "\n\n";
 
  cout << "f\t= " << f << "\n\t\t\t\t" << f(10) << "\n";
  cout << "g\t= " << g << "\n\t\t\t\t" << g(10) << "\n";
  cout << "-f\t= " << -f << "\n\t\t\t\t" << (-f)(10) << "\n";
  cout << "f+g\t= " << f+g << "\n\t\t\t\t" << (f+g)(10) << "\n";
  cout << "f-g\t= " << f-g << "\n\t\t\t\t" << (f-g)(10) << "\n";
  cout << "f*g\t= " << f*g << "\n\t\t\t\t" << (f*g)(10) << "\n";
  cout << "f/g\t= " << f/g << "\n\t\t\t\t" << (f/g)(10) << "\n";
  cout << "2*g\t= " << 2*g << "\n\t\t\t\t" << (2*g)(10) << "\n";
  cout << "g*2\t= " << g*2 << "\n\t\t\t\t" << (g*2)(10) << "\n";
  cout << "g/2\t= " << g/2 << "\n\t\t\t\t" << (g/2)(10) << "\n";
  return 0;
}
