
/******************************************************************************
* MODULE     : literal.cpp
* DESCRIPTION: Literal expressions (the leafs of a plain generic)
* COPYRIGHT  : (C) 2005  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "literal.hpp"
#include "generic_internal.hpp"
namespace mmx {

generic
flatten (const literal& s) {
  return as<generic> (s);
}

string
literal_to_string (const generic& g) {
  return *as<literal> (g);
}

generic::generic ():
  rep (new generic_concrete_rep<literal> (literal (""))) {}

generic::generic (char* s):
  rep (new generic_concrete_rep<literal> (literal (s))) {}

generic::generic (const string& s):
  rep (new generic_concrete_rep<literal> (literal (s))) {}

} // namespace mmx
