
/******************************************************************************
* MODULE     : double_glue.cpp
* DESCRIPTION: Standard glue for double
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "double_meta.hpp"
#include "category_glue.hpp"
#include "literal.hpp"
namespace mmx {

double
make_literal_double (const literal& lit) {
  return as_double (*lit);
}

void
define_double () {
  define_type<always,double> ("Double");
  define<always> ("literal_floating", make_literal_double);
  define_field<always,double> ();
  //define_elementary<always,double> ();
  define_ordering<always,double> ();
  define_upgrader<always,double,int> (PENALTY_CAST);
}

} // namespace mmx
