
/******************************************************************************
* MODULE     : integer_glue.cpp
* DESCRIPTION: Standard glue for integers
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "integer_meta.hpp"
#include "category_glue.hpp"
#include "literal.hpp"
namespace mmx {

static integer
as_integer (const int& i) {
  return i;
}

static generic
integer_constructor_int (const int& i) {
  return as<generic> (integer (i));
}

void
define_integer () {
  define_type<always,integer> ("Integer");
  define<always> ("literal_integer", make_literal<integer>);
  define_euclidean_ring<always,integer> ();
  define_ordering<always,integer> ();
  define_constructor<always,int> (integer_constructor_int);
  define_upgrader<always,int,integer> (as_int, PENALTY_HOMOMORPHISM);
  define_caster<always,integer,int> (as_integer, PENALTY_CAST);
}

} // namespace mmx
